VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSpeechSynthesizerOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2022

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&

Private Const IID_ISpeechSynthesizerOptions As String = "{a0e23871-cc3d-43c9-91b1-ee185324d83d}"
Private Const IID_ISpeechSynthesizerOptions2 As String = "{1cbef60e-119c-4bed-b118-d250c3a25793}"
Private Const IID_ISpeechSynthesizerOptions3 As String = "{401ed877-902c-4814-a582-a5d0c0769fa8}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_QueryInterface = 0
    IUnknown_Release = 2
    
    ' ISpeechSynthesizerOptions
    ISpeechSynthesizerOptions_GetIncludeWordBoundaryMetadata = 6
    ISpeechSynthesizerOptions_PutIncludeWordBoundaryMetadata = 7
    ISpeechSynthesizerOptions_GetIncludeSentenceBoundaryMetadata = 8
    ISpeechSynthesizerOptions_PutIncludeSentenceBoundaryMetadata = 9
                        
    ' ISpeechSynthesizerOptions2
    ISpeechSynthesizerOptions2_GetAudioVolume = 6
    ISpeechSynthesizerOptions2_PutAudioVolume = 7
    ISpeechSynthesizerOptions2_GetSpeakingRate = 8
    ISpeechSynthesizerOptions2_PutSpeakingRate = 9
    ISpeechSynthesizerOptions2_GetAudioPitch = 10
    ISpeechSynthesizerOptions2_PutAudioPitch = 11
                        
    ' ISpeechSynthesizerOptions3
    ISpeechSynthesizerOptions3_GetAppendedSilence = 6
    ISpeechSynthesizerOptions3_PutAppendedSilence = 7
    ISpeechSynthesizerOptions3_GetPunctuationSilence = 8
    ISpeechSynthesizerOptions3_PutPunctuationSilence = 9
    
End Enum

Public Enum SpeechAppendedSilence
    SpeechAppendedSilence_Default = 0
    SpeechAppendedSilence_Min = 1
End Enum

Public Enum SpeechPunctuationSilence
    SpeechPunctuationSilence_Default = 0
    SpeechPunctuationSilence_Min = 1
End Enum

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

' ----==== Variablen ====----
Private m_pISpeechSynthesizerOptions As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    '
End Sub

Private Sub Class_Terminate()
    Call Release(m_pISpeechSynthesizerOptions)
End Sub

' ----==== Properties ====----
Public Property Let ISpeechSynthesizerOptions(ByVal pISpeechSynthesizerOptions As Long)
    Call Release(m_pISpeechSynthesizerOptions)
    m_pISpeechSynthesizerOptions = pISpeechSynthesizerOptions
End Property

Public Property Get ISpeechSynthesizerOptions() As Long
    ISpeechSynthesizerOptions = m_pISpeechSynthesizerOptions
End Property

Public Property Get IncludeWordBoundaryMetadata() As Boolean
    Dim bolRet As Boolean
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim bolValue As Boolean
        If Invoke(m_pISpeechSynthesizerOptions, _
                  ISpeechSynthesizerOptions_GetIncludeWordBoundaryMetadata, _
                  VarPtr(bolValue)) = S_OK Then
            bolRet = bolValue
        End If
    End If
    IncludeWordBoundaryMetadata = bolRet
End Property

Public Property Let IncludeWordBoundaryMetadata(ByVal Value As Boolean)
    If m_pISpeechSynthesizerOptions <> 0& Then
        If Invoke(m_pISpeechSynthesizerOptions, _
                  ISpeechSynthesizerOptions_PutIncludeWordBoundaryMetadata, _
                  Value) = S_OK Then
        
        End If
    End If
End Property

Public Property Get IncludeSentenceBoundaryMetadata() As Boolean
    Dim bolRet As Boolean
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim bolValue As Boolean
        If Invoke(m_pISpeechSynthesizerOptions, _
                  ISpeechSynthesizerOptions_GetIncludeSentenceBoundaryMetadata, _
                  VarPtr(bolValue)) = S_OK Then
            bolRet = bolValue
        End If
    End If
    IncludeSentenceBoundaryMetadata = bolRet
End Property

Public Property Let IncludeSentenceBoundaryMetadata(ByVal Value As Boolean)
    If m_pISpeechSynthesizerOptions <> 0& Then
        If Invoke(m_pISpeechSynthesizerOptions, _
                  ISpeechSynthesizerOptions_PutIncludeSentenceBoundaryMetadata, _
                  Value) = S_OK Then
        
        End If
    End If
End Property

Public Property Get AudioVolume() As Double
    Dim dblRet As Double
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions2 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions2)), _
                  VarPtr(pISpeechSynthesizerOptions2)) = S_OK Then
            Dim dblValue As Double
            If Invoke(pISpeechSynthesizerOptions2, _
                      ISpeechSynthesizerOptions2_GetAudioVolume, _
                      VarPtr(dblValue)) = S_OK Then
                dblRet = dblValue
            End If
            Call Release(pISpeechSynthesizerOptions2)
        End If
    End If
    AudioVolume = dblRet
End Property

Public Property Let AudioVolume(ByVal Value As Double)
    If m_pISpeechSynthesizerOptions <> 0& And _
       Value >= CDbl(0) And Value <= CDbl(1) Then
        Dim pISpeechSynthesizerOptions2 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions2)), _
                  VarPtr(pISpeechSynthesizerOptions2)) = S_OK Then
            If Invoke(pISpeechSynthesizerOptions2, _
                      ISpeechSynthesizerOptions2_PutAudioVolume, _
                      Value) = S_OK Then
        
            End If
            Call Release(pISpeechSynthesizerOptions2)
        End If
    End If
End Property

Public Property Get SpeakingRate() As Double
    Dim dblRet As Double
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions2 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions2)), _
                  VarPtr(pISpeechSynthesizerOptions2)) = S_OK Then
            Dim dblValue As Double
            If Invoke(pISpeechSynthesizerOptions2, _
                      ISpeechSynthesizerOptions2_GetSpeakingRate, _
                      VarPtr(dblValue)) = S_OK Then
                dblRet = dblValue
            End If
            Call Release(pISpeechSynthesizerOptions2)
        End If
    End If
    SpeakingRate = dblRet
End Property

Public Property Let SpeakingRate(ByVal Value As Double)
    If m_pISpeechSynthesizerOptions <> 0& And _
       Value >= CDbl(0.5) And Value <= CDbl(6) Then
        Dim pISpeechSynthesizerOptions2 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions2)), _
                  VarPtr(pISpeechSynthesizerOptions2)) = S_OK Then
            If Invoke(pISpeechSynthesizerOptions2, _
                      ISpeechSynthesizerOptions2_PutSpeakingRate, _
                      Value) = S_OK Then
        
            End If
            Call Release(pISpeechSynthesizerOptions2)
        End If
    End If
End Property

Public Property Get AudioPitch() As Double
    Dim dblRet As Double
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions2 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions2)), _
                  VarPtr(pISpeechSynthesizerOptions2)) = S_OK Then
            Dim dblValue As Double
            If Invoke(pISpeechSynthesizerOptions2, _
                      ISpeechSynthesizerOptions2_GetAudioPitch, _
                      VarPtr(dblValue)) = S_OK Then
                dblRet = dblValue
            End If
            Call Release(pISpeechSynthesizerOptions2)
        End If
    End If
    AudioPitch = dblRet
End Property

Public Property Let AudioPitch(ByVal Value As Double)
    If m_pISpeechSynthesizerOptions <> 0& And _
       Value >= CDbl(0) And Value <= CDbl(2) Then
        Dim pISpeechSynthesizerOptions2 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions2)), _
                  VarPtr(pISpeechSynthesizerOptions2)) = S_OK Then
            If Invoke(pISpeechSynthesizerOptions2, _
                      ISpeechSynthesizerOptions2_PutAudioPitch, _
                      Value) = S_OK Then
        
            End If
            Call Release(pISpeechSynthesizerOptions2)
        End If
    End If
End Property

Public Property Get AppendedSilence() As SpeechAppendedSilence
    Dim eRet As SpeechAppendedSilence
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions3 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions3)), _
                  VarPtr(pISpeechSynthesizerOptions3)) = S_OK Then
            Dim eValue As Long
            If Invoke(pISpeechSynthesizerOptions3, _
                      ISpeechSynthesizerOptions3_GetAppendedSilence, _
                      VarPtr(eValue)) = S_OK Then
                eRet = eValue
            End If
            Call Release(pISpeechSynthesizerOptions3)
        End If
    End If
    AppendedSilence = eRet
End Property

Public Property Let AppendedSilence(ByVal Value As SpeechAppendedSilence)
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions3 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions3)), _
                  VarPtr(pISpeechSynthesizerOptions3)) = S_OK Then
            If Invoke(pISpeechSynthesizerOptions3, _
                      ISpeechSynthesizerOptions3_PutAppendedSilence, _
                      Value) = S_OK Then
        
            End If
            Call Release(pISpeechSynthesizerOptions3)
        End If
    End If
End Property

Public Property Get PunctuationSilence() As SpeechPunctuationSilence
    Dim eRet As SpeechPunctuationSilence
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions3 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions3)), _
                  VarPtr(pISpeechSynthesizerOptions3)) = S_OK Then
            Dim eValue As Long
            If Invoke(pISpeechSynthesizerOptions3, _
                      ISpeechSynthesizerOptions3_GetPunctuationSilence, _
                      VarPtr(eValue)) = S_OK Then
                eRet = eValue
            End If
            Call Release(pISpeechSynthesizerOptions3)
        End If
    End If
    PunctuationSilence = eRet
End Property

Public Property Let PunctuationSilence(ByVal Value As SpeechPunctuationSilence)
    If m_pISpeechSynthesizerOptions <> 0& Then
        Dim pISpeechSynthesizerOptions3 As Long
        If Invoke(m_pISpeechSynthesizerOptions, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_ISpeechSynthesizerOptions3)), _
                  VarPtr(pISpeechSynthesizerOptions3)) = S_OK Then
            If Invoke(pISpeechSynthesizerOptions3, _
                      ISpeechSynthesizerOptions3_PutPunctuationSilence, _
                      Value) = S_OK Then
        
            End If
            Call Release(pISpeechSynthesizerOptions3)
        End If
    End If
End Property

' ----==== Subs & Functions ====----
Private Sub Release(ByRef pInterface As Long)
    Dim lngRet As Long
    If pInterface <> 0& Then
        Call Invoke(pInterface, IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
                           ByVal lngCmd As Long, _
                           ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
End Function

