VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "WinRT SpeechSynthesizer Demo"
   ClientHeight    =   6555
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   8670
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   437
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   578
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frDivers 
      Caption         =   "Divers"
      Height          =   885
      Left            =   60
      TabIndex        =   14
      Top             =   5580
      Width           =   8535
      Begin VB.CommandButton cmdSaveAsWave 
         Caption         =   "Save Text to Wav"
         Height          =   555
         Left            =   5700
         TabIndex        =   17
         Top             =   240
         Width           =   2760
      End
      Begin VB.CommandButton cmdPauseSpeech 
         Caption         =   "Pause Speech"
         Height          =   555
         Left            =   2910
         TabIndex        =   16
         Top             =   240
         Width           =   2745
      End
      Begin VB.CommandButton cmdPlaySpeech 
         Caption         =   "Play Speech"
         Height          =   555
         Left            =   90
         TabIndex        =   15
         Top             =   240
         Width           =   2760
      End
   End
   Begin VB.Frame frSsml 
      Caption         =   "Ssml"
      Height          =   2715
      Left            =   60
      TabIndex        =   11
      Top             =   2820
      Width           =   8535
      Begin VB.TextBox tbSsml 
         Height          =   1755
         Left            =   90
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   13
         Top             =   240
         Width           =   8355
      End
      Begin VB.CommandButton cmdSynthesizeSsml 
         Caption         =   "Ssml to Speech: Infos auf https://www.w3.org/TR/speech-synthesis/"
         Height          =   555
         Left            =   90
         TabIndex        =   12
         Top             =   2070
         Width           =   8355
      End
   End
   Begin VB.Frame frText 
      Caption         =   "Text"
      Height          =   2715
      Left            =   3960
      TabIndex        =   8
      Top             =   60
      Width           =   4635
      Begin VB.CommandButton cmdSythesizeText 
         Caption         =   "Text to Speech"
         Height          =   555
         Left            =   90
         TabIndex        =   10
         Top             =   2070
         Width           =   4455
      End
      Begin VB.TextBox tbText 
         Height          =   1755
         Left            =   90
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   9
         Top             =   240
         Width           =   4455
      End
   End
   Begin VB.Frame frOptions 
      Caption         =   "SpeakingRate"
      Height          =   645
      Index           =   2
      Left            =   60
      TabIndex        =   6
      Top             =   2130
      Width           =   3855
      Begin VB.HScrollBar sbSpeekingRate 
         Height          =   285
         Left            =   90
         Max             =   600
         Min             =   50
         TabIndex        =   7
         Top             =   240
         Value           =   50
         Width           =   3675
      End
   End
   Begin VB.Frame frOptions 
      Caption         =   "Pitch"
      Height          =   645
      Index           =   1
      Left            =   60
      TabIndex        =   4
      Top             =   1440
      Width           =   3855
      Begin VB.HScrollBar sbPitch 
         Height          =   285
         Left            =   90
         Max             =   200
         TabIndex        =   5
         Top             =   240
         Width           =   3675
      End
   End
   Begin VB.Frame frOptions 
      Caption         =   "Volume"
      Height          =   645
      Index           =   0
      Left            =   60
      TabIndex        =   2
      Top             =   750
      Width           =   3855
      Begin VB.HScrollBar sbVolume 
         Height          =   285
         Left            =   90
         Max             =   100
         TabIndex        =   3
         Top             =   240
         Width           =   3675
      End
   End
   Begin VB.Frame frVoices 
      Caption         =   "Voices"
      Height          =   645
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   3855
      Begin VB.ComboBox cbVoices 
         Height          =   315
         Left            =   90
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   240
         Width           =   3675
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2022

Option Explicit

Private WithEvents cSpeechSynthesizer As clsSpeechSynthesizer
Attribute cSpeechSynthesizer.VB_VarHelpID = -1
Private cSpeechSynthesizerOptions As clsSpeechSynthesizerOptions

Private Sub cSpeechSynthesizer_MediaEnded(ByVal sender As Long)
    If sender = cSpeechSynthesizer.IMediaPlayer Then
        Debug.Print "MediaEnded"
    End If
End Sub

Private Sub Form_Load()

    Dim lngVoicesItem As Long
    Dim lngVoicesCount As Long
    Dim lngDefVoiceItem As Long
    Dim cAllVoice As clsVoiceInformation
    Dim cDefVoice As clsVoiceInformation

    Set cSpeechSynthesizer = New clsSpeechSynthesizer
    Set cDefVoice = cSpeechSynthesizer.DefaultVoice
    Set cSpeechSynthesizerOptions = cSpeechSynthesizer.options
    
    lngVoicesCount = cSpeechSynthesizer.AllVoicesCount
    If lngVoicesCount > 0& Then
        For lngVoicesItem = 0& To lngVoicesCount - 1
            Set cAllVoice = cSpeechSynthesizer.AllVoiceByIndex(lngVoicesItem)
           
            If cAllVoice.Id = cDefVoice.Id Then lngDefVoiceItem = lngVoicesItem
            
            Dim strGender As String
            Select Case cAllVoice.Gender
                Case VoiceGender.VoiceGender_Male
                    strGender = ", Male"
                Case VoiceGender.VoiceGender_Female
                    strGender = ", Female"
            End Select
            
            Call cbVoices.AddItem(Replace$(cAllVoice.Description, ")", strGender & ")"))
            
        Next
        
        cbVoices.ListIndex = lngDefVoiceItem
    End If
    
    sbVolume.Value = cSpeechSynthesizerOptions.AudioVolume * 100
    sbPitch.Value = cSpeechSynthesizerOptions.AudioPitch * 100
    sbSpeekingRate.Value = cSpeechSynthesizerOptions.SpeakingRate * 100

    tbText.Text = "Dieser Text, wird ber die WinRT SpeechSynthesizer COM-Interfaces " & _
                  "und die WinRT WindowsMedia COM-Interfaces ausgegeben. Wer Fehler " & _
                  "im Code findet, darf diese gern verbessern. ;-) Die Stimme hrt sich " & _
                  "etwas natrlicher an, wenn man den Pitch so zwischen 0,7 und 0,8 einstellt."

    tbSsml.Text = "<speak version='1.0' xmlns='http://www.w3.org/2001/10/synthesis' xml:lang='en-US'>" & vbNewLine & _
                  "Hallo <prosody contour='(0%,+80Hz) (10%,+80%) (40%,+80Hz)'>Benutzer.</prosody> " & vbNewLine & _
                  "<break time='500ms'/>" & vbNewLine & _
                  "Auf Wiedersehen. <prosody rate='slow' contour='(0%,+20Hz) (10%,+30%) (40%,+10Hz)'>Bis zum nchsten mal.</prosody>" & vbNewLine & _
                  "</speak>"

    cSpeechSynthesizerOptions.AudioPitch = 0.7
    Call cSpeechSynthesizer.SynthesizeText("Herzlich willkommen bei der WinRT SpeechSynthesizer Demo.")
    cSpeechSynthesizerOptions.AudioPitch = 1

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set cSpeechSynthesizer = Nothing
    Set cSpeechSynthesizerOptions = Nothing
End Sub

Private Sub cmdSythesizeText_Click()
    Call cSpeechSynthesizer.SynthesizeText(tbText.Text)
End Sub

Private Sub cmdSynthesizeSsml_Click()
    Call cSpeechSynthesizer.SynthesizeSsml(tbSsml.Text)
End Sub

Private Sub cmdPauseSpeech_Click()
    Call cSpeechSynthesizer.Pause
End Sub

Private Sub cmdPlaySpeech_Click()
    Call cSpeechSynthesizer.Play
End Sub

Private Sub cmdSaveAsWave_Click()
    Call cSpeechSynthesizer.SynthesizeText(tbText.Text, True)
End Sub

Private Sub cbVoices_Click()
    cSpeechSynthesizer.Voice = cSpeechSynthesizer.AllVoiceByIndex(cbVoices.ListIndex)
End Sub

Private Sub sbVolume_Change()
    cSpeechSynthesizerOptions.AudioVolume = CDbl(sbVolume.Value / 100)
    frOptions(0).Caption = "Volume: " & Format$(CDbl(sbVolume.Value / 100), "0.00")
End Sub

Private Sub sbVolume_Scroll()
    cSpeechSynthesizerOptions.AudioVolume = CDbl(sbVolume.Value / 100)
    frOptions(0).Caption = "Volume: " & Format$(CDbl(sbVolume.Value / 100), "0.00")
End Sub

Private Sub sbPitch_Change()
    cSpeechSynthesizerOptions.AudioPitch = CDbl(sbPitch.Value / 100)
    frOptions(1).Caption = "Pitch: " & Format$(CDbl(sbPitch.Value / 100), "0.00")
End Sub

Private Sub sbPitch_Scroll()
    cSpeechSynthesizerOptions.AudioPitch = CDbl(sbPitch.Value / 100)
    frOptions(1).Caption = "Pitch: " & Format$(CDbl(sbPitch.Value / 100), "0.00")
End Sub

Private Sub sbSpeekingRate_Change()
    cSpeechSynthesizerOptions.SpeakingRate = CDbl(sbSpeekingRate.Value / 100)
    frOptions(2).Caption = "SpeekingRate: " & Format$(CDbl(sbSpeekingRate.Value / 100), "0.00")
End Sub

Private Sub sbSpeekingRate_Scroll()
    cSpeechSynthesizerOptions.SpeakingRate = CDbl(sbSpeekingRate.Value / 100)
    frOptions(2).Caption = "SpeekingRate: " & Format$(CDbl(sbSpeekingRate.Value / 100), "0.00")
End Sub


