Attribute VB_Name = "modITypedEventHandler_MediaEnded"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2022

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const E_NOINTERFACE As Long = &H80004002
Private Const IID_IUnknown As String = "{00000000-0000-0000-c000-000000000046}"
Private Const ITypedEventHandler_Windows_Media_Playback_MediaPlayer_IInspectable As String = "{f1a6a51e-d078-5c40-ba3f-348870ba5c87}"

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

Private Type tInterface
    pVTable As Long
End Type

Private Type tInterface_VTable
    VTable(0 To 3) As Long
End Type

' ----==== Ole32.dll Declarations ====----
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long

' ----==== Variablen ====----
Private m_RefCount As Long
Private m_Class As clsSpeechSynthesizer
Private m_Interface As tInterface
Private m_Interface_VTable As tInterface_VTable

Public Function Create(ByVal cSpeechSynthesizer As clsSpeechSynthesizer, _
                       ByRef pInterface As Long) As Boolean
    Set m_Class = cSpeechSynthesizer
    With m_Interface_VTable
        .VTable(0) = ProcPtr(AddressOf QueryInterface)
        .VTable(1) = ProcPtr(AddressOf AddRef)
        .VTable(2) = ProcPtr(AddressOf Release)
        .VTable(3) = ProcPtr(AddressOf Invoke)
    End With
    With m_Interface
        .pVTable = VarPtr(m_Interface_VTable)
    End With
    pInterface = VarPtr(m_Interface)
    Create = True
End Function

Private Function ProcPtr(ByVal ptr As Long) As Long
    ProcPtr = ptr
End Function

Private Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0 Then
        strGUID = Left$(strGUID, lngRet - 1)
    Else
        strGUID = vbNullString
    End If
    Guid2Str = strGUID
End Function

Private Function QueryInterface(ByVal this As Long, _
                                ByRef riid As GUID, _
                                ByRef pvObj As Long) As Long
    Dim lRet As Long
    Select Case UCase$(Guid2Str(riid))
    Case UCase$(IID_IUnknown), UCase$(ITypedEventHandler_Windows_Media_Playback_MediaPlayer_IInspectable)
        Call AddRef(this)
        pvObj = VarPtr(m_Interface)
        lRet = S_OK
    Case Else
        pvObj = 0&
        lRet = E_NOINTERFACE
    End Select
    QueryInterface = lRet
End Function

Private Function AddRef(ByVal this As Long) As Long
    m_RefCount = m_RefCount + 1
    AddRef = m_RefCount
End Function

Private Function Release(ByVal this As Long) As Long
    m_RefCount = m_RefCount - 1
    Release = m_RefCount
End Function

Private Function Invoke(ByVal this As Long, _
                        ByVal sender As Long, _
                        ByVal args As Long) As Long
    Call m_Class.Invoke_MediaEnded(sender)
End Function

